<script lang="ts">
  import { UserProfileInfoByIdStore } from "$houdini";
  import HeaderWithBackdrop from "$lib/components/ui-elements/HeaderWithBackdrop.svelte";
  import { Spinner } from "flowbite-svelte";
  import { authTokenParsed } from "$stores/authStore";
  import BadgeCard from "$lib/components/pages/results/BadgeCard.svelte";

  /** @type {import("./$types").PageData} // Data from +page.ts */
  export let data;
  $: userProfileStore = new UserProfileInfoByIdStore();

  async function fetchAwards() {
    const response = await userProfileStore.fetch({
      variables: {
        user_id: $authTokenParsed!.id,
        user_uuid: $authTokenParsed!.id
      }
    });
    if (response.errors || !response.data) {
      throw new Error("Failed to fetch user profile");
    }
    console.log(response.data);
    return response.data.awards_assertions.map(a => ({
      ...a,
      badgr: response.data?.c2games_user_by_pk?.badges?.find(b => b.id === a.badgr_assertion_id)
    }));
  }
</script>

<div class="w-full">
  {#await fetchAwards()}
    <Spinner></Spinner>
  {:then awards}
    <section class="flex flex-col mx-5 2xl:mx-auto 2xl:w-10/12">
      <HeaderWithBackdrop size="sm" secondary wrap>You've Earned Bragging Rights</HeaderWithBackdrop>
      <p class="py-1">
        Show off your accomplishment and hard work from this competition as you enter the workforce!
      </p>
      <p class="py-1">
        <i>Candidates with competition experience on their resumes are significantly more likely to receive interviews
          and hires!</i>
      </p>
      <p class="py-1">
        The NCAE Organization has partnered with <a target="_blank" href="https://badgr.com/">Canvas Badges</a>
        to make it quick and easy to add your NCAE badge to your resume and social media profiles!
      </p>

      <div class="grid pt-4 grid-cols-1 sm:grid-cols-2 xl:grid-cols-3 gap-4">
        {#each awards as award}
          {#if award.badgr}
            <a target="_blank" class="contents"
               href="{award.badgr.assertion_url}?identity__email={encodeURIComponent(award.badgr.recipient_id)}">
              <BadgeCard {award} />
            </a>
          {:else}
            <BadgeCard {award} />
          {/if}
        {/each}
      </div>
    </section>
  {/await}
</div>

